// once every 10 min for 24 hours -> 144
#define num_datasets 200
#define set_interval 108 //every 7.2 min

struct wp
{
  uint8_t inp;
  uint8_t out;
};
wp wp_arr[num_datasets];
uint16_t datasetpt = 0;
uint16_t datact = 0;

void storewp(uint8_t inp, uint8_t out,bool wp)
{
  // there will be one each 4 seconds, 15 each minute
  if (datact == 0)
  {
    wp_arr[datasetpt].inp = inp;
    wp_arr[datasetpt].out = out;
    datasetpt++;
    if (datasetpt >= num_datasets) datasetpt = 0;
  }
  datact++;
  if (datact >= set_interval) datact = 0;
}

void handleRoot() 
{
  String out;
  char temp[20];
  out += "In ";
  sprintf(temp,"%d",tempin);
  out += temp;
  out += " Out ";
  sprintf(temp,"%d",tempout);
  out += temp;
  if (wpon)
    out += " WP on\r\n";
  else
    out += " WP off\r\n";
  server.send(200, "text/plain", out);
}

void handleNotFound() 
{
  server.send(404, "text/plain", "Not Here");
}

//   server.on("/test.svg", drawGraph);
void drawGraph() 
{
  String out;
  out.reserve(2000);
  char temp[100];
  out += "<svg viewBox=\"0 0 400 62\" xmlns=\"http://www.w3.org/2000/svg\">\n";
  out += "<line x1=\"0\" y1=\"60\" x2=\"400\" y2=\"60\" stroke=\"grey\" />\n";
  out += "<line x1=\"0\" y1=\"10\" x2=\"400\" y2=\"10\" stroke=\"grey\" />\n";
  
  out += "<polyline points=\"";
  for (int i=0;i<num_datasets;i++)
  {
    // datasetpt is now, show the past
    uint16_t pos = datasetpt + i;
    if (pos >= num_datasets) pos -= num_datasets;
    sprintf(temp,"%d,%d ",2*i,60-wp_arr[pos].out);
    out += temp;
  }
  out += "\" fill=\"none\" stroke=\"red\" />\n";
  
  out += "<polyline points=\"";
  for (int i=0;i<num_datasets;i++)
  {
    // datasetpt is now, show the past
    uint16_t pos = datasetpt + i;
    if (pos >= num_datasets) pos -= num_datasets;
    sprintf(temp,"%d,%d ",2*i,60-wp_arr[pos].inp);
    out += temp;
  }
  out += "\" fill=\"none\" stroke=\"green\" />\n";

  out += "</svg>\n";
  
  server.send(200, "image/svg+xml", out);
}
